
setOldClass(c("pmat","block","vstack"))

  exinv <- function(r, n)
  {
  # analytic form of inverse of compound symmetry matrix
        den <- (n - 1) * r * r - (n - 2) * r - 1
        ans <- matrix(r/den, nr = n, nc = n)
        diag(ans) <-  - ((n - 2) * r + 1)/den
        ans
  }


BT.scalefun <- function(R, ID, cor.met, p=ncol(MX), df.smooth) {
# from section 3.3 of LZ 1986 & section 3.1.b Equation(12) of BT 1998
        N <- length(R)  #
#
        sum(R^2)/(N - (p+df.smooth))    

#The error of degree of freedom df_err=total number of observations - (1 +(sum of df due to pa
#rametric predictors)+(sum of df due to nonparametric predictors))
#Note that p=1+(sum of df due to parametric predictors)
}

excori<-function(x)
{
	N <- length(x$r)
	o <- matrix(x$alpha, nr = N, nc = N)
	diag(o) <- 1
	solve(o)
}
excoriput<- function(x)
{
# quick calculation of exch. working covariance
	exinv(x$alpha, length(x$r))
}
bspline.smoother<-function(x)
{
	x.data <- unique(sort(x))
	n <- length(x.data)
	m1 <- n - 2
	m2 <- m1 - 1
	h.data <- x.data[-1] - x.data[ - length(x.data)]	#Prepare Q and R zero matrices for assignment
	q.matrix <- matrix(0, nrow = length(x.data), ncol = length(h.data) - 1)
	r.matrix <- matrix(0, nrow = length(x.data) - 2, ncol = length(x.data) - 2)
	for(i in 1:m1) {
#Assign values for Q
		q.matrix[i, i] <- (1/h.data)[i]
		q.matrix[i + 2, i] <- (1/h.data)[i + 1]
		q.matrix[i + 1, i] <- (-1/h.data[-1] - 1/h.data[ - length(h.data)])[i]	#Diagonal values for R
		r.matrix[i, i] <- ((h.data[-1] + h.data[ - length(h.data)])/6)[i]
	}
	for(i in 1:m2) {
#Paradiagonal values for R
		r.matrix[i + 1, i] <- (((h.data[-1])[ - length(h.data[-1])])/6)[i]
		r.matrix[i, i + 1] <- (((h.data[-1])[ - length(h.data[-1])])/6)[i]
	}
#K = Q(R^-1)Q'
	k.matrix <- q.matrix %*% solve(r.matrix) %*% t(q.matrix)	#To use smooth.spline to find smoothing parameter lambda
#K maitrx returned for further calculation should ties and weights be present
	k.matrix
}
LZ.ar1.coriput<-function(x)
{
	x.alpha <- as.numeric(x$alpha[(x$cor.met[, 1])[1]])
	times <- as.numeric(x$cor.met[, 2])
	if(length(times) == 1) {
		R.alpha.inv <- 1
	}
	if(length(times) > 1) {
		time.diff <- abs(outer(times, times, FUN = "-"))
		R.alpha.inv <- solve(x.alpha^time.diff)
	}
	R.alpha.inv
}
plot.cdgam<-function(x, ci.option = "mb", j = NULL, ci = F, resid = F)
{
	if(ci.option == "emp")
		se.smooth <- x$nonpar$se.emp
	if(ci.option == "mb")
		se.smooth <- x$nonpar$se.mb
	smooth <- x$nonpar$smooth.terms
	if(dim(smooth)[2] == 1)
		x.values <- matrix(x$x.smooth, ncol = 1)
	if(dim(smooth)[2] > 1)
		x.values <- x$x.smooth
	x.names <- dimnames(se.smooth)[[2]]	
	#Identify name of predictor to plot
	if(is.null(j)) {
		for(i in 1:length(x.names)) {
			x.name.i <- x.names[i]	
	#Select name for ith smooth term
			x.value.i <- unique(as.numeric(x.values[, i]))	#Prepare values for x.axis
			x.smooth.mu <- unique(as.numeric(smooth[, i]))	
	#Prepare values for mean of curve
			x.smooth.se <- unique(as.numeric(se.smooth[,i]))	
	#Prepare values for standard error of curve
			if(ci == T) {
				spar.i <- smooth.spline(x.value.i, x.smooth.mu)$spar
				fitted.se.max <- sort(smooth.spline(x.value.i, (x.smooth.mu + 1.96 * x.smooth.se), spar = spar.i)$y)
				fitted.se.min <- sort(smooth.spline(x.value.i, (x.smooth.mu - 1.96 * x.smooth.se), spar = spar.i)$y)
				y.min <- (min(fitted.se.min) - 1)
				y.max <- (max(fitted.se.max) + 1)
			}
			if(ci == F) {
				if(resid == T) {
				  y.min <- (min(x.smooth.mu) - 1)
				  y.max <- (max(x.smooth.mu) + 1)
				}
				if(resid == F) {
				  y.values.fitted <- smooth.spline(x.value.i, x.smooth.mu)$y
				  y.min <- (min(y.values.fitted) - 1)
				  y.max <- (max(y.values.fitted) + 1)
				}
			}
#Identify minumum & maximum y-value
			if(resid == T) {
				plot(x.value.i, x.smooth.mu, ylim
				   = c(y.min, y.max), ylab = paste("eta value due to", x.name.i),xlab = paste("original x-values for", x.name.i))
				lines(smooth.spline(x.value.i, x.smooth.mu), lty = 1, lwd = 2)
				spar.i <- smooth.spline(x.value.i, x.smooth.mu)$spar
			}
			else {
				plot(x.value.i, x.smooth.mu, ylim = c(y.min, y.max), ylab = paste("eta value due to", x.name.i),xlab = paste("original x-values for", x.name.i), type = "n")
				lines(smooth.spline(x.value.i, x.smooth.mu), lty = 1, lwd = 2)
				spar.i <- smooth.spline(x.value.i,x.smooth.mu)$spar
			}
			if(ci == T) {
				par(new = T)
				lines(smooth.spline(x.value.i, (x.smooth.mu - 1.96 * x.smooth.se),spar = spar.i), lty = 8)
				par(new = T)
				lines(smooth.spline(x.value.i, (x.smooth.mu + 1.96 * x.smooth.se),spar = spar.i), lty = 8)
			}
		}
	}
	else {
#Identify name of predictor to plot
		x.name.j <- x.names[j]	
	#Select name for ith smooth term
		x.value.j <- unique(as.numeric(x.values[, j]))	
	#Prepare values for x.axis
		x.smooth.mu <- unique(as.numeric(smooth[, j]))	
	#Prepare values for mean of curve
		x.smooth.se <- unique(as.numeric(se.smooth[, j]))	
	#Prepare values for standard error of curve
		if(ci == T) {
			spar.j <- smooth.spline(x.value.j, x.smooth.mu)$spar
			fitted.se.max <- sort(smooth.spline(x.value.j, (x.smooth.mu + 1.96 * x.smooth.se), spar = spar.j)$y)
			fitted.se.min <- sort(smooth.spline(x.value.j, (x.smooth.mu - 1.96 * x.smooth.se), spar = spar.j)$y)
			y.min <- (min(fitted.se.min) - 1)
			y.max <- (max(fitted.se.max) + 1)
		}
		if(ci == F) {
			if(resid == T) {
				y.min <- (min(x.smooth.mu) - 1)
				y.max <- (max(x.smooth.mu) + 1)
			}
			if(resid == F) {
				y.values.fitted <- smooth.spline(x.value.j, x.smooth.mu)$y
				y.min <- (min(y.values.fitted) - 1)
				y.max <- (max(y.values.fitted) + 1)
			}
		}
#Identify minumum & maximum y-value
		if(resid == T) {
			plot(x.value.j, x.smooth.mu, ylim = c(y.min,y.max), ylab = paste("eta value due to", x.name.j), xlab = paste("original x-values for", x.name.j))
			lines(smooth.spline(x.value.j, x.smooth.mu),lty = 1, lwd = 2)
			spar.j <- smooth.spline(x.value.j, x.smooth.mu)$spar
		}
		else {
			plot(x.value.j, x.smooth.mu, ylim = c(y.min,y.max), ylab = paste("eta value due to", x.name.j), xlab = paste("original x-values for",x.name.j), type = "n")
			lines(smooth.spline(x.value.j, x.smooth.mu),lty = 1, lwd = 2)
			spar.j <- smooth.spline(x.value.j, x.smooth.mu)$spar
		}
		if(ci == T) {
			par(new = T)
			lines(smooth.spline(x.value.j, (x.smooth.mu -1.96 * x.smooth.se), spar = spar.j),lty = 8)
			par(new = T)
			lines(smooth.spline(x.value.j, (x.smooth.mu +1.96 * x.smooth.se), spar = spar.j),lty = 8)
		}
		else invisible(x)
	}
}
summary.cdgam<-function(object)
{
# summary.yags
# based on yags calling cdgam.par for parametric part, and correlation structure calculations
	coef <- object$para$coefficients
	resid <- object$residuals
	n <- length(resid)
	nas <- is.na(coef)
	cnames <- names(coef[!nas])
	coef <- matrix(rep(coef[!nas], 5), ncol = 5)
	dimnames(coef) <- list(cnames, c("Estimate", "Naive S.E.", "Naive z", "Robust S.E.", "Robust z"))
	rse <- sqrt(diag(object$para$robust.parmvar))
	nse <- sqrt(diag(object$para$naive.parmvar))
	coef[, 2] <- nse
	coef[, 3] <- coef[, 1]/coef[, 2]
	coef[, 4] <- rse
	coef[, 5] <- coef[, 1]/coef[, 4]
	summary <- list()
	summary$call <- object$call
	summary$version <- object$para$version	
	summary$parametric.coefficients <- coef	#based on Gauss-Seidel algorithm calling gam.yags.smooth.fit for non-parametric part
	df.nl <- object$nonparametric$df.nl
	df.approx <- object$nonparametric$df.approx
	T.s.emp <- object$nonparametric$T.s.emp
	T.s.chisq <- object$nonparametric$T.s.chisq
	cnames.nonpar <- dimnames(object$nonparametric$se.emp)[[2]]
	coef.smooth <- cbind(df.nl, df.approx, T.s.emp, T.s.chisq)
	dimnames(coef.smooth) <- list(cnames.nonpar, c("Df exact", "Df approx", "empirical Chisq", "P(Chi)"))
	summary$coef.smooth <- coef.smooth
	summary$scale <- object$para$phi
	summary$alpha <- as.numeric(object$para$alpha)
	attr(summary, "class") <- "summary.cdgam"
	summary
}
strat.excoriput<-function(x)
{
# quick calculation of exch. working covariance
	exinv(x$alpha[x$cor.met[1]], length(x$r))
}
ar1.coriput<-function(x)
{
#although an analytic form for the inverse
#of the AR(1) ac matrix is available, its use
#is not so straightforward with gappy data
	solve(x$alpha^dist2full(dist(x$cor.met)))
}

unstr.coriput<-function(x)
{
	solve(x$alpha[x$cor.met, x$cor.met])
}

yags.links<-structure(.Data = list("Identity: mu", link = function(mu)
mu, inverse = function(eta)
eta, deriv = function(mu)
1, initialize = expression({
	y <- as.numeric(y)
	mu <- y
}
), dinv.deta = function(eta)
{
	1
}
, "Logit: log(mu/(1 - mu))", link = function(mu)
log(mu/(1 - mu)), inverse = function(eta)
{
	junk <- care.exp(eta)
	junk/(1 + junk)
}
, deriv = function(mu)
{
	d <- mu * (1 - mu)
	if(any(tiny <- (d < .Machine$double.eps))) {
		warning("Model unstable; fitted probabilities of 0 or 1")
		d[tiny] <- .Machine$double.eps
	}
	1/d
}
, initialize = expression({
	if(is.matrix(y)) {
		if(dim(y)[2] > 2)
			stop("only binomial response matrices (2 columns)")
		n <- drop(y %*% c(1, 1))
		y <- y[, 1]
	}
	else {
		if(is.category(y))
			y <- y != levels(y)[1]
		else y <- as.vector(y)
		n <- rep(1, length(y))
	}
	w <- w * n
	n[n == 0] <- 1
	y <- y/n
	mu <- y + (0.5 - y)/n
}
), dinv.deta = function(eta)
{
	junk <- care.exp(eta)
	junk/(1 + junk)^2
}
, "Complementary Log: log( - log(1 - mu))", link = function(mu)
log( - log(1 - mu)), inverse = function(eta)
{
	junk <- care.exp(eta)
	1 - care.exp( - junk)
}
, deriv = function(mu)
{
	mu2 <- 1 - mu
	d <-  - (mu2 * log(mu2))
	if(any(tiny <- (d < .Machine$double.eps))) {
		warning("Model unstable; fitted probabilities of 0 or 1")
		d[tiny] <- .Machine$double.eps
	}
	1/d
}
, initialize = expression({
	if(is.matrix(y)) {
		if(dim(y)[2] > 2)
			stop("only binomial response matrices (2 columns)")
		n <- drop(y %*% c(1, 1))
		y <- y[, 1]
	}
	else {
		if(is.category(y))
			y <- y != levels(y)[1]
		else y <- as.vector(y)
		n <- rep(1, length(y))
	}
	w <- w * n
	n[n == 0] <- 1
	y <- y/n
	mu <- y + (0.5 - y)/n
}
), dinv.deta = function(eta)
{
	junk <- care.exp(eta)
	care.exp(eta - junk)
}
, "Probit: qnorm(mu)", link = function(mu)
qnorm(mu), inverse = function(eta)
pnorm(eta), deriv = function(mu)
sqrt(2 * pi) * exp((qnorm(mu)^2)/2), initialize = expression({
	if(is.matrix(y)) {
		if(dim(y)[2] > 2)
			stop("only binomial response matrices (2 columns)")
		n <- drop(y %*% c(1, 1))
		y <- y[, 1]
	}
	else {
		if(is.category(y))
			y <- y != levels(y)[1]
		else y <- as.vector(y)
		n <- rep(1, length(y))
	}
	w <- w * n
	n[n == 0] <- 1
	y <- y/n
	mu <- y + (0.5 - y)/n
}
), dinv.deta = function(eta)
{
	dnorm(eta)
}
, "Log: log(mu)", link = function(mu)
log(mu), inverse = function(eta)
care.exp(eta), deriv = function(mu)
1/mu, initialize = expression({
	if(!is.null(dimy <- dim(y))) {
		if(dimy[2] > 1)
			stop("multiple responses not allowed")
		else y <- drop(y)
	}
	else y <- as.numeric(y)
	mu <- y + 0.167 * (y == 0)
}
), dinv.deta = function(eta)
{
	care.exp(eta)
}
, "Inverse: 1/mu", link = function(mu)
1/mu, inverse = function(eta)
1/eta, deriv = function(mu)
-1/mu^2, initialize = expression({
	y <- as.numeric(y)
	mu <- y + 0.167 * (y == 0)
}
), dinv.deta = function(eta)
{
	-1/eta^2
}
, "Inverse Square: 1/mu^2", link = function(mu)
1/mu^2, inverse = function(eta)
sqrt(1/eta), deriv = function(mu)
-2/mu^3, initialize = expression({
	mu <- y + 0.167 * (y == 0)
}
), dinv.deta = function(eta)
{
	-0.5 * eta^(-1.5)
}
, "Square Root: sqrt(mu)", link = function(mu)
sqrt(mu), inverse = function(eta)
eta^2, deriv = function(mu)
1/(2 * sqrt(mu)), initialize = expression({
	y <- as.numeric(y)
	mu <- y + 0.167 * (y == 0)
}
), dinv.deta = function(eta)
{
	2 * eta
}
), .Dim = c(6, 8), .Dimnames = list(c("names", "link", "inverse", "deriv", "initialize", "dinv.deta"), c("identity", "logit", "cloglog", 
	"probit", "log", "inverse", "1/mu^2", "sqrt")))
identni<-function(x)
{
# independence model
# returns the identity matrix
	diag(length(x$r))
}
BT.exchalp<-function(R, ID, cor.met = NULL, scalefun, p, df.smooth)
{
# example 3, section 4 of LZ 1986
	residlist <- split.preserveord(R, ID)
	A0 <- 0
	den <- 0
	n <- unlist(lapply(residlist, length))
	for(i in 1:length(residlist)) {
		if(n[i] > 1) {
# 
# 
			A0 <- A0 + (sum(residlist[[i]] %*% t(residlist[[i]])) - t(residlist[[i]]) %*% residlist[[i]])/2	# 
			den <- den + 0.5 * n[i] * (n[i] - 1)
		}
	}
# 
	P <- scalefun(R, ID, cor.met, p, df.smooth)	# 
	A0/(P * (den - (p+df.smooth)))
}
pmat<-function(classdef, p = NULL)
{
	out <- list()
	class(out) <- c("pmat", classdef)
	out
}
pmat2mat<-function(x)
{
	if(inherits(x, "diag"))
		stop("will not convert block diagonals")
	R <- rdim(x)
	C <- cdim(x)
	N <- length(x)
	k <- 0
	if(inherits(x, "vstack")) {
		out <- matrix(NA, nr = sum(rdim(x)), nc = cdim(x)[1])
		for(i in 1:N) {
			k <- k + R[i]
			j <- k - R[i] + 1
			out[j:k,  ] <- x[[i]]
		}
	}
	else if(inherits(x, "hstack")) {
		out <- matrix(NA, nc = sum(cdim(x)), nr = rdim(x)[1])
		for(i in 1:N) {
			k <- k + C[j]
			j <- k - C[j] + 1
			out[, j:k] <- x[[i]]
		}
	}
	else stop("pmat to matrix conversions only defined for hstack and vstack")
	out
}

is.scalar<-function(x)
is.atomic(x) & length(x) == 1
fill<-function(matfun, genarg, outclass)
{
# version 1.5.1.5 98/08/26
# matfun takes one argument of undetermined type
# matfun must return an s-matrix
#
# genarg must be a list, elements of which are
# recognizeable to matfun 
#
# outclass will only be partly checked
#
	I <- length(genarg)
	out <- lapply(genarg, matfun)
	cdims <- unlist(lapply(out, function(x)
	ncol(x)))
	rdims <- unlist(lapply(out, function(x)
	nrow(x)))
	ccom <- F
	rcom <- F
	if(all(cdims == cdims[1]))
		ccom <- T
	if(all(rdims == rdims[1]))
		rcom <- T
	if(match("vstack", outclass, nom = F) & !ccom)
		warning("output is not a vstack (different cdim elements)")
	if(match("hstack", outclass, nom = F) & !rcom)
		warning("output is not an hstack (different rdim elements)")
	class(out) <- outclass
	attr(out, "cdims") <- cdims
	attr(out, "rdims") <- rdims
	out
}
"%*%.pmat"<-function(x, y, ...)
{
	NextMethod("%*%.pmat")
}
"%*%.pmat.block"<-function(x, y, ...)
{
	nelx <- length(x)
	nely <- length(y)
	if(nelx != nely)
		stop("nonconforming pmats (different numbers of blocks)")
	if(length(attr(x, "cdims")) > 0 & length(attr(y, "rdims")) > 0) {
		if(any(attr(x, "cdims") != attr(y, "rdims")))
			stop("nonconforming pmats")
	}
	if(!is.loaded(symbol.C("pmat_mult"))) {
		out <- list()
		for(i in 1:nelx) {
			out[[i]] <- x[[i]] %*% y[[i]]
		}
	}
	else {
		xr <- attr(x, "rdims")
		yc <- attr(y, "cdims")
		ans <- list()
		for(i in 1:nelx) {
			if(any(c(dim(x[[i]]), dim(y[[i]])) == 0) | is.null(dim(x[[i]])) | is.null(dim(y[[i]])))
				stop(paste("some factor (", i, ") has improper dimension"))
			ans[[i]] <- matrix(0, nr = xr[i], nc = yc[i])
		}
		z <- .C("pmat_mult",
			x,
			y,
			ans = ans,
			as.integer(length(x)))
		out <- z$ans
	}
	class(out) <- c("pmat", "block")
	if(inherits(x, "diag") & inherits(y, "diag"))
		class(out) <- c(class(out), "diag")
	attr(out, "rdims") <- attr(x, "rdims")
	attr(out, "cdims") <- attr(y, "cdims")
	out
}

"*.pmat"<-function(x, y, ...)
{
	NextMethod("*.pmat")
}
"*.pmat.block"<-function(x, y, ...)
{
	if(!is.scalar(x))
		stop("* only defined for scalar * pmat")
	out <- list()
	for(i in 1:length(y))
		out[[i]] <- x * y[[i]]
	attributes(out) <- attributes(y)
	class(out) <- class(y)
	out
}

"+.pmat"<-function(x, y, ...)
{
	NextMethod("+.pmat")
}


"+.pmat.block"<-function(x, y, ...)
{
	nelx <- length(x)
	if(length(x) != length(y))
		stop("+: pmats must be of same length")
	if(!(all(attr(x, "cdims") == attr(y, "cdims")) & all(attr(x, "rdims") == attr(y, "rdims"))))
		stop("nonconforming addends")
	if(!is.loaded(symbol.C("pmat_add"))) {
		out <- list()
		for(i in 1:nelx)
			out[[i]] <- x[[i]] + y[[i]]
	}
	else {
		out <- 0 * x
		for(i in 1:nelx)
			if(any(c(dim(x[[i]]), dim(y[[i]])) == 0) | is.null(dim(x[[i]])) | is.null(dim(y[[i]]))) stop(paste("some factor (", 
				  i, ") has improper dimension"))
		z <- .C("pmat_add",
			x,
			y,
			ans = out,
			as.integer(length(x)))
		out <- z$ans
	}
	attributes(out) <- attributes(x)
	out
}

BT.prop.ar1alp<-function(R, ID, cor.met, scalefun, p, df.smooth)
{
# following SAS (tm) 6.12 tech report, p294
	r <- split.preserveord(R, ID)
	times <- split.preserveord(cor.met, ID)
	num <- 0
	den <- 0
	n <- unlist(lapply(r, length))
	for(i in 1:length(r)) {
		curnum <- 0
		curden <- 0
		contrib <- F
		if(n[i] > 1) {
			for(j in 1:(n[i] - 1)) {
				if((times[[i]][j + 1] - times[[i]][j]) == 1) {
				  curnum <- curnum + r[[i]][j] * r[[i]][j + 1]
				  curden <- curden + 1
				  contrib <- T
				}
			}
			if(contrib) {
				num <- num + curnum/curden
				den <- den + 1
			}
		}
	}
	P <- scalefun(R, ID, cor.met, p, df.smooth)
	num/(P * den)
}
sum.pmat<-function(x, na.rm = F)
NextMethod("sum.pmat")
sum.pmat.block<-function(x, na.rm = F)
{
	if(!(all(attr(x, "cdims") == attr(x, "cdims")[1]) & all(attr(x, "rdims") == attr(x, "rdims")[1])))
		stop("needs all dimensions common")
	if(!is.loaded(symbol.C("pmat_sum"))) {
		out <- x[[1]]
		for(i in 2:length(x))
			out <- out + x[[i]]
		class(out) <- "matrix"
	}
	else {
		ans.space <- 0 * x[[1]]
		z <- .C("pmat_sum",
			x,
			as.integer(length(x)),
			ans = ans.space)
		out <- z$ans
	}
	out
}
solve.pmat<-function(x, ...)
NextMethod("solve.pmat")
solve.pmat.block<-function(x, ...)
NextMethod("solve.pmat.block")
solve.pmat.block.default<-function(x)
{
	stop("inverse not defined for general block mat")
}

solve.pmat.block.diag<-function(x)
{
	out <- lapply(x, solve)
	attributes(out) <- attributes(x)
	out
}


t.pmat<-function(x)
NextMethod("t.pmat")


t.pmat.block<-function(pmat)
{
	out <- list()
	out <- lapply(pmat, t)
	attributes(out) <- attributes(pmat)
	attr(out, "rdims") <- attr(pmat, "cdims")
	attr(out, "cdims") <- attr(pmat, "rdims")
	if(inherits(pmat, "vstack"))
		class(out) <- c("pmat", "block", "hstack")
	if(inherits(pmat, "hstack"))
		class(out) <- c("pmat", "block", "vstack")
	if(inherits(pmat, "diag"))
		class(out) <- c("pmat", "block", "diag")
	out
}


det<-function(x)
UseMethod("det")

det.default<-function(x)
prod(eigen(x)$val)


BT.prop.unstruc.alp<-function(R, ID, cor.met, scalefun, p, df.smooth)
{
# following SAS (tm) 6.12 tech report, p294
	r <- split.preserveord(R, ID)
	utimes <- 1:max(cor.met)
	nt <- length(utimes)
	q <- (nt * (nt - 1))/2
	alp <- matrix(0, nt, nt)
	den <- matrix(0, nt, nt)
	times <- split.preserveord(cor.met, ID)
	num <- 0
	n <- unlist(lapply(r, length))
	for(i in 1:length(r)) {
		contrib <- F
		if(n[i] > 1) {
			for(j in 1:(n[i] - 1)) {
				for(k in (j + 1):n[i]) {
				  alp[times[[i]][j], times[[i]][k]] <- alp[times[[i]][j], times[[i]][k]] + r[[i]][j] * r[[i]][k]
				  den[times[[i]][j], times[[i]][k]] <- den[times[[i]][j], times[[i]][k]] + 1
				}
			}
		}
	}
	P <- scalefun(R, ID, cor.met, p, df.smooth)
	den <- den + t(den)
	diag(den) <- 1	# avoid div by zero
	alp <- alp + t(alp)
	alp <- alp/(P * den)
	diag(alp) <- 1
	alp
}
det.pmat<-function(x, ...)
NextMethod("det.pmat")



det.pmat.block<-function(x, ...)
NextMethod("det.pmat.block")




det.pmat.block.default<-function(x)
{
	stop("determinant not defined for general block mat")
}




det.pmat.block.diag<-function(x)
{
	out <- lapply(x, function(x)
	prod(eigen(x)$val))
	attributes(out) <- attributes(x)
	out
}





cdim<-function(x)
attr(x, "cdim")






rdim<-function(x)
attr(x, "rdim")







msplit<-function(mat, vec)
{
	if(nrow(mat) != length(vec)) {
		print("msplit: dimension error.")
		return()
	}
	ns <- dimnames(mat)[[2]]
	tstruc <- split.preserveord(as.vector(vec), as.vector(vec))
	ngrp <- length(tstruc)
	nco <- ncol(mat)
	start <- 1
	for(i in 1:ngrp) {
		thislen <- length(tstruc[[i]])
		end <- start + thislen - 1
		tstruc[[i]] <- matrix(mat[seq(start, end),  ], ncol = nco)
		dimnames(tstruc[[i]]) <- list(NULL, ns)
		start <- end + 1
	}
	tstruc
}








dist2full<-function(dis)
{
	n <- attr(dis, "Size")
	full <- matrix(0, n, n)
	full[lower.tri(full)] <- dis
	full + t(full)
}
full2tri<-function(x)
{
	if(any(x - t(x)))
		warning("x not symmetric")
	as.numeric(x[row(x) >= col(x)])
}
tri2full<-function(x)
{
	k <- length(x)
	n <- 0.5 * (sqrt(1 + 8 * k) - 1)
	ans <- matrix(0, n, n)
	ans[row(ans) >= col(ans)] <- x
	d <- diag(ans)
	ans <- ans + t(ans)
	diag(ans) <- d
	ans
}
Bt.strat.exchalp<-function(R, ID, cor.met, scalefun, p, df.smooth)
{
# example 3, section 4 of LZ 1986 & modified by BT 1998
# note at this stage cor.met is a vector
# this function assumes a common scale parameter;
	residlist <- split.preserveord(R, ID)
	cor.met <- split.preserveord(cor.met, ID)
	if(is.matrix(cor.met[[1]]))
		stop("strat.exchalp can't handle matrices in cor.met")
	dim.alpha <- length(unique(unlist(cor.met)))
	if(any(sort(unique(unlist(cor.met))) != 1:dim.alpha))
		stop("strat.exchalp needs cor.met elements 1:n.strata")
	A0 <- rep(0, dim.alpha)
	den <- rep(0, dim.alpha)
	n <- unlist(lapply(residlist, length))
	for(i in 1:length(residlist)) {
		met.ind <- cor.met[[i]][1]
		if(n[i] > 1) {
			A0[met.ind] <- A0[met.ind] + (sum(residlist[[i]] %*% t(residlist[[i]])) - t(residlist[[i]]) %*% residlist[[i]])/2
			den[met.ind] <- den[met.ind] + 0.5 * n[i] * (n[i] - 1)
		}
	}
	P <- scalefun(R, ID, cor.met, p, df.smooth)
	A0/(P * (den - (p+df.smooth)))
}
split.preserveord<-function(x, disc)
{
	tmpn <- unique(disc)
	ansscr <- split(x, disc)
	ord <- match(tmpn, names(ansscr))
	ansscr[ord]
}
load.clustered.design<-function(x, id)
fill(transfer.matfun, msplit(x, id), c("pmat", "block", "vstack"))
load.clustered.outcome<-function(y, id)
fill(transfer.matfun, vsplit(y, id), c("pmat", "block", "vstack"))
load.bd.weight<-function(matfun, genarg)
{
	fill(matfun, genarg, c("pmat", "block", "diag"))
}
vsplit<-function(vec, disc)
{
	lapply(split.preserveord(vec, disc), function(x)
	matrix(x, nc = 1))
}
transfer.matfun<-function(x)
{
	if(!is.matrix(x))
		stop("transfer.matfun must receive a matrix")
	x
}

ngau.m2ll<-function(res, alpha, wcorigen, var, id, cor.met)
{
	print(alpha)
	N <- length(res)
	I <- length(unique(id))
	TT <- split.preserveord(cor.met, id)
	corclass <- unlist(lapply(TT, function(x)
	x[1]))
	sizes <- unlist(lapply(TT, length))
	cor.els <- list()
	for(i in 1:I)
		cor.els[[i]] <- list(alpha = alpha[corclass[i]], ni = sizes[i])
	Rinv.i <- fill(wcorigen, cor.els, c("pmat", "block", "diag"))
	Siginv.i <- (1/var) * Rinv.i
	D.i <- det(Siginv.i)
	R.i <- load.clustered.outcome(res, id)	# structure resids
	WCPa.i <- t(R.i) %*% Siginv.i
	WCP.i <- WCPa.i %*% R.i	# 
# 
	N * log(2 * pi) - sum(log(unlist(D.i))) + sum(WCP.i)
}
gau.hetex.alp<-function(R, ID, cor.met, scalefun, p)
{
	assign("ID", ID, 1)
	assign("cor.met", cor.met, 1)
	P <- scalefun(R, ID, cor.met, p)
	ans <- ms( ~ ngau.m2ll(R, alp, nexinv, P, ID, cor.met), start = list(alp = initalp), control = list(maxiter = 15, maxfcalls = 25, 
		rel.tolerance = 0.0001))$par
	initalp <<- ans
	ans
}
nexinv<-function(x)
{
	n <- x$ni
	r <- x$alpha	# analytic form of inverse of compound symmetry matrix
	den <- (n - 1) * r * r - (n - 2) * r - 1
	ans <- matrix(r/den, nr = n, nc = n)
	diag(ans) <-  - ((n - 2) * r + 1)/den
	ans
}
make.exch.cor.genarg<-function(rho, id)
{
	ni <- unlist(lapply(split.preserveord(id, id), length))
	N <- length(ni)
	ga <- list()
	for(i in 1:N) {
		ga[[i]]$ni <- ni[i]
		ga[[i]]$rho <- rho
	}
	ga
}
cdgam<-function(formula, id, lambda = NULL, weights = NULL, cor.met = NULL, family = gaussian, alpfun = NULL, scalefun = BT.scalefun, wcorigen = 
	identni, tol = 0.001, contrasts = NULL, corstr = c("independence", "exchangeable", "ar1", "unstructured"), maxiter = 25, gamob, data)
{
	attach(data)
#Section 1. Receive gam object as starting point to get initial estimate of terms & Pearson's residuals
	smooth.pointer <- attributes(terms(gamob$formula, gam.slist))$specials$s	#Point out column(s) of smoothed variable(s) 
#Select the smoothed terms as starting values for Gauss-Siedel algorithm later on
	x.smooth <- gamob$x[, smooth.pointer]	#Prepare data matrix of smoothing terms for calculation later on
	f.smooth <- as.matrix(predict(gamob, type = "terms")[, (smooth.pointer - 1)], ncol = length(smooth.pointer))
	f.smooth.names <- dimnames(gamob$smooth)[[2]]
	dimnames(f.smooth) <- list(NULL, f.smooth.names)	#Obtain smoothed part of eta as initial values in global eta.smooth calculation
	if(length(smooth.pointer) == 1)
		eta.smooth <- as.numeric(f.smooth)
	else if(length(smooth.pointer) > 1)
		eta.smooth <- apply(f.smooth, 1, "sum")
	df.smooth <- sum(gamob$nl.df)	
	#Compute initial estimate of sum of degrees of freedom as calculated in initial gamob to be passed into gam.yags.pmat.fit & gam.yags.smooth.fit
#Section 2. Compute list of lambda.K matrices to be passed into gam.yags.smooth.fit iteratively
	smooth.lambda.K <- list()	#Prepare list to receive lambda.K for each smoothing component
	incidence.matrix <- list()	#Prepare list to receive incidence matrices for 
#Solving for smoother matrix S for each smoothing term, and store each lambda.K in a list called smooth.lambda.K.list
	lambda.values <- list()	#Prepare list to receive lambda values used for smoothing
	if(length(lambda) == 0) {
		for(i in 1:length(smooth.pointer)) {
			if(length(smooth.pointer) == 1)
				x.smooth.subject <- x.smooth
			if(length(smooth.pointer) > 1)
				x.smooth.subject <- x.smooth[, i]
			test.s <- matrix(rep(unique(x.smooth.subject), length(x.smooth.subject)), byrow = T, ncol = length(unique(
				x.smooth.subject)))
			n <- length(unique(x.smooth.subject))
			test.incidence.matrix <- matrix(0, nrow = dim(test.s)[1], ncol = dim(test.s)[2])
			for(i in 1:n) {
				test.incidence.matrix[, i] <- (test.s[, i] == x.smooth.subject)
			}
			lambda.i <- ((max(x.smooth.subject) - min(x.smooth.subject))^3) * smooth.spline(x.smooth.subject)$spar	
	#Find the value of lambda that optimized the smooth.See help fine for smooth.spline
#Call bspline.smooth to compute K=Q(R^-1)Q'
			K.matrix <- bspline.smoother(x.smooth.subject)
			incidence.matrix[[i]] <- test.incidence.matrix
			smooth.lambda.K[[i]] <- K.matrix * lambda.i
			lambda.values[[i]] <- lambda.i
		}
	}
	if(length(lambda) > 0) {
		for(i in 1:length(smooth.pointer)) {
			if(length(smooth.pointer) == 1)
				x.smooth.subject <- x.smooth
			if(length(smooth.pointer) > 1)
				x.smooth.subject <- x.smooth[, i]
			test.s <- matrix(rep(unique(x.smooth.subject), length(x.smooth.subject)), byrow = T, ncol = length(unique(
				x.smooth.subject)))
			n <- length(unique(x.smooth.subject))
			test.incidence.matrix <- matrix(0, nrow = dim(test.s)[1], ncol = dim(test.s)[2])
			for(i in 1:n) {
				test.incidence.matrix[, i] <- (test.s[, i] == x.smooth.subject)
			}
			lambda.i <- lambda[i]	#Call bspline.smooth to compute K=Q(R^-1)Q'
			K.matrix <- bspline.smoother(x.smooth.subject)
			incidence.matrix[[i]] <- test.incidence.matrix
			smooth.lambda.K[[i]] <- K.matrix * lambda.i
			lambda.values[[i]] <- lambda.i
		}
	}
#Section 3. Load modified form of yags
	prog.error <- NULL
	corstr <- corstr[1]	# option list curtailed if default chosen
	if(is.null(cor.met) & !(corstr == "independence" | corstr == "exchangeable"))
		stop("must supply cor.met for non-independence, non-exchangeable")
	if(corstr == "unstructured" && any(cor.met - floor(cor.met))) {
		warning("cor.met not lattice-valued; flooring")
		cor.met <- floor(cor.met)
	}
	call <- match.call()
	m <- match.call(expand = F)
	m$contrasts <- m$tol <- m$wcorigen <- m$scalefun <- m$alpfun <- m$family <- m$cor.met <- m$id <- m$corstr <- m$maxiter <- m$gamob <- 
		m$verbose <- NULL
	m <- m[-3]	#To remove the gam object gamob from affecting subsequent calls
	m[[1]] <- as.name("model.frame")
	m <- eval(m, sys.parent())
	Terms <- attr(m, "terms")
	y <- as.matrix(model.extract(m, response))	# 1.5.1.1 B : add weight-processing specifically for binomial matrices
# corrected in 1.5.1.3!!
# as in glm()
	if(is.null(weights))
		weights <- rep(1, nrow(y))
	else if(length(weights) != nrow(y))
		stop("lengths of y and weights incompatible")
	if(ncol(y) == 2) {
		n <- apply(y, 1, sum)
		y <- y[, 1, drop = F]/n
		weights <- 1/(weights * n)
	}
	else weights <- 1/weights
	x <- model.matrix(Terms, m, contrasts)
	Y <- load.clustered.outcome(y, id)
	X <- load.clustered.design(x, id)
	if(!is.null(alpfun) & corstr != "independence")
		warning("both alpfun and non-default corstr provided; corstr will be ignored")
	else if(corstr[1] == "exchangeable") {
		alpfun <- BT.exchalp
		wcorigen <- excoriput
	}
	else if(corstr[1] == "ar1") {
		if(is.null(cor.met)) stop("must supply times (cor.met) with ar1")	# use next line to emulate SAS 6.12 genmod
		alpfun <- BT.prop.ar1alp
		wcorigen <- ar1.coriput
	}
	else if(corstr[1] == "unstructured") {
		if(is.null(cor.met)) stop("must supply times (cor.met) with unstructured")	# use next two lines to emulate genmod 6.12	
# use next two lines for emulation of Groemping macro unstr
		alpfun <- BT.prop.unstruc.alp
		wcorigen <- unstruc.coviput
	}
	else if(is.null(alpfun) & corstr[1] == "independence") {
		alpfun <- function(a, b, c, d, p, df.smooth)
		0
		wcorigen <- identni
	}
	dim.MX.f.init <- dim(pmat2mat(X))
	MX.f.init <- matrix(0, ncol = dim.MX.f.init[2], nrow = dim.MX.f.init[1])
	f.init <- cbind(MX.f.init, f.smooth)	
	#Create initial values of parametric f.i for convergence checking (essentially zero to start with).
	ans <- list()	#To perform parametric marginal estimation by modified form of GEE
	del <- 1
	iter <- 0
	tol <- 0.0005
	while(del > tol) {
		iter <- iter + 1
		print(paste("Starting back-fitting iteration", iter))
		ans.parametric <- cdgam.par(X, Y, ID = id, eta.smooth, df.smooth, weights, cor.met, family = family, alpfun, 
			scalefun, wcorigen, tol, maxiter, prog.error)	
	#To use Rinv.i, parametric eta, phi for gam.yags.smooth.fit calculations
#Assign & update values needed for gam.yags.smooth.fit calculations
		eta <- ans.parametric$linear.predictors
		eta.parametric <- ans.parametric$eta.parametric
		phi <- ans.parametric$phi
		Rinv.i <- ans.parametric$Rinv.i	
	#Retrive componentwise f.i for parametric part of the model to test for convergence criteria
		MX.f.i <- ans.parametric$MX * matrix(rep(as.numeric(ans.parametric$b0), dim(ans.parametric$MX)[1]), ncol = dim(
			ans.parametric$MX)[2], byrow = T)	
	#Commence Gauss-Seidel smoothing algorithm using the updated eta, eta.parametric, phi, and Rinv.i
		ans.nonparametric <- cdgam.nonpar(smooth.lambda.K, incidence.matrix, f.smooth, x.smooth, smooth.pointer, df.smooth, 
			Y, ID = id, eta, eta.parametric, family = family, Rinv.i, phi, tol = 1, maxiter = 15)	
	#Assign & update values needed for gam.yags.pmat.fit calculations if iteration persists
		df.smooth <- sum(ans.nonparametric$df.nl)
		f.smooth <- ans.nonparametric$smooth.terms
		dimnames(f.smooth) <- list(NULL, f.smooth.names)
		f.new <- cbind(MX.f.i, f.smooth)
		if(length(smooth.pointer) == 1)
			eta.smooth <- as.numeric(f.smooth)
		else if(length(smooth.pointer) > 1)
			eta.smooth <- apply(f.smooth, 1, "sum")
		del <- max(apply(abs(f.new - f.init), 1, "sum"))/sum(apply(abs(f.init), 1, "sum"))
		f.init <- f.new	#Update f.init for comparison in the next interation
	}
	ans$para <- ans.parametric
	ans$nonparametric <- ans.nonparametric
	ans$lambdaK <- smooth.lambda.K
	ans$lambda <- lambda.values
	ans$x.smooth <- x.smooth
	ans$incidence.matrix <- incidence.matrix
	ans$final.eta <- eta.smooth + eta.parametric	#calculate final values for eta
#Calculation of pearson's chi-suqared statistics as a quadratic approximation to deviance
#See Chamber & Hastie Pg 245.
	final.mu <- family()$inverse(ans$final.eta)
	final.A <- as.double(family()$variance(final.mu)) * weights	# 
	if(length(final.A) == 1) final.A <- rep(final.A, length(unlist(Y)))	
	# This is important because for family is gaussian, the value of A is 1 and length(A) is 1. By doing this, we avoid having dimension mismatch in matrix multiplication.
	final.response.resid <- unlist(Y) - final.mu	# Response residual
	final.pearson.resid <- final.response.resid/sqrt(final.A)	#Pearson's residual
	final.Deviance <- sum(final.pearson.resid^2)	#Calculate nonparametric version of AIC.  Hastie & Tibshirani pg. 158.
	final.df.npar <- as.numeric(sum(ans.nonparametric$df.approx))
	final.df.par <- ans.parametric$rank
	ans$deviance <- final.Deviance
	ans$call <- call
	ans$corstr <- corstr	#oldClass(ans) <- c("yags")#,"glm","lm")
	if(version$major < 5)
		class(ans) <- c("cdgam", "glm", "lm")
	else oldClass(ans) <- c("cdgam')
	ans
}
exch.cor<-function(x)
{
	nr <- x$ni
	out <- matrix(x$rho, nr = nr, nc = nr)
	diag(out) <- 1
	out
}
exch.gaussian.loglik<-function(beta, rho, var, y, x, id)
{
	Y <- load.clustered.outcome(y, id)
	X <- load.clustered.design(x, id)
	N <- length(y)
	Sig <- var * load.bd.weight(exch.cor, make.exch.cor.genarg(rho, id))
	D <- det(Sig)
	R <- load.clustered.outcome(y - x %*% beta, id)	# structure resids
	WCPa <- t(R) %*% solve(Sig)
	WCP <- WCPa %*% R
	-0.5 * N * log(2 * pi) - 0.5 * sum(log(unlist(D))) - 0.5 * sum(WCP)
}
cdgam.par<-function(X, Y, ID, eta.smooth, df.smooth, weights, cor.met, family, alpfun, scalefun, wcorigen, tol, maxiter, prog.error)
{
	MX <- pmat2mat(X)
	xn <- dimnames(X[[1]])[[2]]
	dimnames(MX) <- list(NULL, xn)
	initrun <- glm(unlist(Y) ~ MX - 1, family = family, weights = weights)
	b0 <- initrun$coef
	cur.rank <- sum(eigen(t(MX) %*% MX)$val > 0)	# bad!
	del <- 1
	assign("glm.links", yags.links, f = 1)
	iter <- 0
	while((del > tol) & (iter < maxiter)) {
		iter <- iter + 1
		print(paste("Starting iteration", iter, "with coefs"))
		print(as.numeric(b0))
		eta <- MX %*% b0	# 
		eta <- eta + eta.smooth	#eta.smooth reflects contribution from smoothing part of algorithm  
		mu <- family()$inverse(eta)	# 
		d.mu <- family()$deriv(mu)	# 
# 1.5.1.1 E use weights
		A <- as.double(family()$variance(mu)) * weights	# 
		if(length(A) == 1) A <- rep(A, length(unlist(Y)))	
	# This is important because for family is gaussian, the value of A is 1 and length(A) is 1. By doing this, we avoid having dimension mismatch in matrix multiplication.
		D.i <- load.clustered.design((1/sqrt(A)) * as.double(family()$dinv.deta(eta)) * MX, ID)	# D scaled by V(mu)
		PR <- (1/sqrt(A)) * (unlist(Y) - mu)	#Pearson's residual
		if(!is.null(cor.met) & !is.matrix(cor.met))
			TT <- split.preserveord(cor.met, ID)
		else if(!is.null(cor.met) & is.matrix(cor.met))
			TT <- msplit(cor.met, ID)
		else TT <- NULL
		alpha <- alpfun(PR, ID, cor.met, scalefun, p = ncol(MX), df.smooth)
		PR <- load.clustered.outcome(PR, ID)
		cor.els <- list()
		NC <- length(PR)
		for(i in 1:NC)
			cor.els[[i]] <- list(r = PR[[i]], cor.met = TT[[i]], alpha = alpha)
		Rinv.i <- fill(wcorigen, cor.els, c("pmat", "block", "diag"))
		S2 <- solve(sum(t(D.i) %*% Rinv.i %*% D.i))
		delb <- S2 %*% sum(t(D.i) %*% Rinv.i %*% PR)
		del <- max(abs(delb))
		b1 <- b0 + delb
		b0 <- b1
	}
# wrap up using final beta values
	if(iter == maxiter) {
		warning("maximum number of iterations consumed")
		prog.error <- c(prog.error, "niter==maxiter")
	}
	eta <- MX %*% b0
	eta <- eta + eta.smooth	#eta.smooth reflects contribution from smoothing part of algorithm  
	mu <- family()$inverse(eta)
	Rvec <- unlist(Y) - mu	# Response residual
	PR.resid <- (1/sqrt(A)) * Rvec	# Pearson's residual
	PR <- PR.resid
	alpha <- alpfun(PR, ID, cor.met, scalefun, p = ncol(MX), df.smooth)
	sealp <- NA
	phi <- scalefun(PR, ID, cor.met, p = ncol(MX), df.smooth)
	PR <- load.clustered.outcome(PR, ID)
	for(i in 1:NC)
		cor.els[[i]] <- list(r = PR[[i]], cor.met = TT[[i]], alpha = alpha)
	vvt <- function(x)
	matrix(x$r %*% t(x$r), nr = length(x$r))
	eet <- fill(vvt, cor.els, c("pmat", "block", "diag"))
	Rinv.i <- fill(wcorigen, cor.els, c("pmat", "block", "diag"))
	S2 <- solve(sum(t(D.i) %*% Rinv.i %*% D.i))
	S5 <- sum(t(D.i) %*% Rinv.i %*% eet %*% Rinv.i %*% D.i)
	eta.parametric <- MX %*% b1	#eta value due to Fisher's scoring algorithm, to be passed for smoothing part later on.
	b1 <- as.numeric(b1)
	names(b1) <- xn
	list(coefficients = b1, naive.parmvar = phi * S2, robust.parmvar = S2 %*% S5 %*% S2, alpha = alpha, phi = phi, linear.predictors = 
		as.double(eta), fitted.values = as.double(mu), pearson.resid = as.numeric(PR.resid), iter = iter, family = family, rank = 
		cur.rank, errorcode = prog.error, eta.parametric = eta.parametric, Rinv.i = Rinv.i, MX = MX, b0 = b0)
}
cdgam.nonpar<-function(smooth.lambda.K, incidence.matrix, f.smooth, x.smooth, smooth.pointer, df.smooth, Y, ID = id, eta, eta.parametric, family, Rinv.i, phi, tol, maxiter)
{
	f.smooth.names <- dimnames(f.smooth)[[2]]
	assign("glm.links", yags.links, f = 1)
	mu <- family()$inverse(eta)	
	#  Initial mu values calculated from final eta carried from gam.yags.pmat.fit where eta=eta.parametric(from yags)+eta.nonpar(from gam.init)
	d.mu <- family()$deriv(mu)	# d.mu=d(eta)/d(mu)	Initial d.mu values carried from gam.yags.pmat.fit
	d.eta <- family()$dinv.deta(eta) # d.eta=d(mu)/d(eta)	Initial d.eta values carried from gam.yags.pmat.fit
	A <- (family()$variance(mu))	#Initial A values carried from gam.yags.pmat.fit
	if(length(A) == 1) d.mu <- d.eta <- A <- rep(A, length(unlist(Y)))	
	# This is important because for family is gaussian, the value of A is 1 and length(A) is 1. By doing this, we avoid having dimension mismatch in matrix multiplication.
	R.list <- lapply(Rinv.i, solve)	#Correlation matrix R(alpha) in list form
	nsizes <- NULL
	nblocks <- length(R.list)
	for(i in 1:nblocks)
		nsizes <- c(nsizes, dim(R.list[[i]])[1])
	ends <- cumsum(nsizes)
	starts <- ends - nsizes + 1
	R.alpha <- matrix(0, sum(nsizes), sum(nsizes))
	for(i in 1:nblocks)
		R.alpha[starts[i]:ends[i], starts[i]:ends[i]] <- R.list[[i]]	
	#W.matrix returns the weight matrix,W, for W=D(V^-1)D and V=(A^1/2)(R.alpha/phi)(A^1/2) 	
	W.matrix <- (diag(d.eta)) %*% (solve((sqrt(diag(A))) %*% (R.alpha/phi) %*% (sqrt(diag(A))))) %*% (diag(d.eta))
	del <- 1
	iter <- 0
	tol <- 0.02
	while((del > tol)) {
		iter <- iter + 1
		f.smooth.new <- matrix(0, ncol = length(smooth.pointer), nrow = length(mu))	#Create dummy matrix for slotting purposes
		print(paste("Starting Gauss-Seidel fitting", iter))
		for(i in 1:length(smooth.pointer)) {
			if(length(smooth.pointer) == 1) {
				incidence.matrix.i <- as.matrix(incidence.matrix[[i]])
				lambdak <- as.matrix(smooth.lambda.K[[i]])
				S.i <- (incidence.matrix.i) %*% solve(t(incidence.matrix.i) %*% W.matrix %*% incidence.matrix.i + lambdak) %*% 
				  t(incidence.matrix.i) %*% W.matrix	#Calculate smoother matrix S for ith predictor 
				z.i <- (matrix(f.smooth)) + (solve(diag(d.mu))) %*% (matrix((unlist(Y) - mu)))
				f.smooth.new <- S.i %*% z.i
			}
			if(length(smooth.pointer) > 1) {
				incidence.matrix.i <- as.matrix(incidence.matrix[[i]])
				lambdak <- as.matrix(smooth.lambda.K[[i]])
				S.i <- (incidence.matrix.i) %*% solve(t(incidence.matrix.i) %*% W.matrix %*% incidence.matrix.i + lambdak) %*% 
				  t(incidence.matrix.i) %*% W.matrix	#Calculate smoother matrix S for ith predictor 
				z.i <- (matrix(f.smooth[, i])) + (solve(diag(d.mu))) %*% (matrix((unlist(Y) - mu)))	
	#Calculate adjusted dependent variable z for the ith predictor 
				f.smooth.new[, i] <- S.i %*% z.i
			}
		}
		if(length(smooth.pointer) == 1)
			eta.nonpar <- f.smooth.new
		if(length(smooth.pointer) > 1) eta.nonpar <- apply(f.smooth.new, 1, "sum")	
	#Calculate updated values of nonparametric part of eta from the current Gauss-Seidel iteration
		eta.new <- as.numeric(eta.nonpar + eta.parametric)	
	#Note that eta.nonpar is updated after every smoothing iteration, while eta.parametric is kept constant as per input until gam.yags.pmat.fit is called for the next time
#as.numeric for eta is to change it back to vector for proper diagonalization later on
		mu <- family()$inverse(eta.new)	#    Updated mu values by current iteration
		d.mu <- family()$deriv(mu)	# d.mu=d(eta)/d(mu)	Updated d.mu values by current iteration
		d.eta <- family()$dinv.deta(eta)	# d.eta=d(mu)/d(eta)	Updated d.eta values by current iteration
		A <- (family()$variance(mu))	#Updated A values by current iteration
		if(length(A) == 1) d.mu <- d.eta <- A <- rep(A, length(unlist(Y)))	
	# This is important because for family is gaussian, the value of A is 1 and length(A) is 1. By doing this, we avoid having dimension mismatch in matrix multiplication.
		W.matrix <- (diag(d.eta)) %*% (solve((sqrt(diag(A))) %*% (R.alpha/phi) %*% (sqrt(diag(A))))) %*% (diag(d.eta))	
	#Updated weight matrix
		if(length(smooth.pointer) == 1)
			del <- max(abs(f.smooth.new - f.smooth)/abs(f.smooth))
		if(length(smooth.pointer) > 1)
			del <- max(apply(abs(f.smooth.new - f.smooth), 1, "sum"))/sum(apply(abs(f.smooth), 1, "sum"))
		dimnames(f.smooth.new) <- list(NULL, dimnames(f.smooth)[[2]])
		f.smooth <- f.smooth.new	#Update smoothing values perparing for next round of iteration
	}
	smoother <- U.f <- list()
	T.s.mb <- df.nl <- df.approx <- NULL
	D.i <- se.mb <- se.emp <- matrix(0, ncol = length(f.smooth.names), nrow = length(eta))	
	#Prepare target for model-based(mb), & emperical(emp) se
	dimnames(f.smooth) <- list(NULL, f.smooth.names)	#Final smoothing terms values & assign names
#Return final, asymptotic approximation of smoother matrices for each smoothing term
	if(length(A) == 1) d.mu <- d.eta <- A <- rep(A, length(unlist(Y)))	
	# This is important because for family is gaussian, the value of A is 1 and length(A) is 1. By doing this, we avoid having dimension mismatch in matrix multiplication.
	U <- diag(d.eta) %*% (solve((sqrt(diag(A))) %*% (R.alpha/phi) %*% (sqrt(diag(A))))) %*% matrix(unlist(Y) - mu)	
	#Define U being U=DV^-1(y-mu) when U is evaluated with eta.nonparametric at Gauss-Seidel convergence
	Vinv <- solve((sqrt(diag(A))) %*% (R.alpha/phi) %*% (sqrt(diag(A))))	
	#Define Vinv=V^-1 for V=(A^1/2R(alpha)A^1/2)/phi evaluated with eta.nonparametric at Gauss-Seidel convergence
	se.emp <- se.mb <- matrix(0, ncol = length(smooth.pointer), nrow = length(mu))	#Create dummy matrix for slotting purposes
	for(i in 1:length(smooth.pointer)) {
#Calculate smoother matrix S for ith predictor	
		incidence.matrix.i <- as.matrix(incidence.matrix[[i]])
		lambdak <- as.matrix(smooth.lambda.K[[i]])
		smoother[[i]] <- S.i <- (incidence.matrix.i) %*% solve(t(incidence.matrix.i) %*% W.matrix %*% incidence.matrix.i + lambdak) %*% 
			t(incidence.matrix.i) %*% W.matrix	#Calculate smoother matrix S for ith predictor 
#Prepare eta, mu, d.mu, d.eta, A where hypothesis testing sets f=0 in finding U(f=0) for calculation model-based score test in CJS section 4.2 paragraph 3.
		n <- length(Y)
		if(length(smooth.pointer) == 1)
			eta.nonpar.f <- rep(0, length(eta.parametric))
		else if(length(smooth.pointer) == 2)
			eta.nonpar.f <- f.smooth[,  - i]
		else if(length(smooth.pointer) > 2)
			eta.nonpar.f <- apply(f.smooth[,  - i], 1, "sum")
		eta.new.f <- as.numeric(eta.nonpar.f + eta.parametric)
		mu.f <- family()$inverse(eta.new.f)	#     mu values where f.i=0
		d.mu.f <- family()$deriv(mu.f)	# d.mu=d(eta)/d(mu)	d.mu values where f.i=0
		d.eta.f <- d.eta <- family()$dinv.deta(eta.new.f)		# d.eta=d(mu)/d(eta)	d.eta values where f.i=0
		A.f <- (family()$variance(mu.f))	#A values where f.i=0
		if(length(A.f) == 1) d.mu.f <- d.eta.f <- A.f <- rep(A.f, length(unlist(Y)))	
	# This is important because for family is gaussian, the value of A is 1 and length(A) is 1. By doing this, we avoid having dimension mismatch in matrix multiplication.
#Prepare eta, mu, d.mu, d.eta for calculation of D.i to be used in Equation 4 of CJS.
		if(length(smooth.pointer) == 1)
			eta.nonpar.i <- as.numeric(f.smooth)
		else if(length(smooth.pointer) == 2)
			eta.nonpar.i <- f.smooth[, i]
		else if(length(smooth.pointer) > 2)
			eta.nonpar.i <- f.smooth[, i]
		eta.new.i <- as.numeric(eta.nonpar.i)
		mu.i <- family()$inverse(eta.new.i)	#     mu values where f.i=0
		d.mu.i <- family()$deriv(mu.i)	# d.mu=d(eta)/d(mu)	d.mu values where f.i=0
		d.eta.i <- family()$dinv.deta(eta.new.i)		# d.eta=d(mu)/d(eta)	d.eta values where f.i=0
		if(length(smooth.pointer) == 1)
			D.i <- d.eta.i
		if(length(smooth.pointer) > 1) D.i[, i] <- d.eta.i	#Slot d(mu)/d(eta.f) into the nxp matrix for calculation of N.f and V.f
		Vinv.f <- solve((sqrt(diag(A.f))) %*% (R.alpha/phi) %*% (sqrt(diag(A.f))))	
	#Calculate Vinv.f=V^-1 matrix when f.u=0 where V=(A^1/2*R(alpha)*A^1/2)/phi
		U.f[[i]] <- diag(d.eta.f) %*% Vinv.f %*% matrix(unlist(Y) - mu.f)	#Define U.f being U=DV^-1(y-mu) when U is evaluated at f=0
#Calculate degree of freedoms for each smoothing term 
		df.nl <- c(df.nl, ((2 * sum(diag(S.i))) - sum(diag(t(S.i) %*% (W.matrix) %*% (S.i) %*% (solve(W.matrix))))))
		df.approx <- c(df.approx, (1.25 * sum(diag(S.i)) - 0.5))	#Calculate degreeof freedom for each nonparametric term Eq.(8) BT
#Calculate model.based standard error for each smoothing term. Eq. (25) BT
		se.mb[, i] <- sqrt(diag(S.i %*% (solve(W.matrix)) %*% (t(S.i))))	
	#Calculate emperical standard error for each smoothing term. Eq. (26) BT
		se.emp[, i] <- sqrt(diag(S.i %*% solve(W.matrix) %*% U %*% t(U) %*% solve(W.matrix) %*% t(S.i)))
	}
	n.f <- length(eta)
	if(length(A) == 1) d.mu <- d.eta <- A <- rep(A, length(unlist(Y)))	
	# This is important because for family is gaussian, the value of A is 1 and length(A) is 1. By doing this, we avoid having dimension mismatch in matrix multiplication.
	N.f <- n.f * solve(t(D.i) %*% Vinv %*% D.i)	#Calculate pxp matrix as per BT CJS 1998 Equation(5)
	V.f <- N.f %*% (t(D.i) %*% Vinv %*% matrix(unlist(Y) - mu) %*% t(matrix(unlist(Y) - mu)) %*% Vinv %*% D.i) %*% (N.f/n.f)	
	#Calculate pxp matrix as per BT CJS 1998 Equation(4)
	for(i in 1:length(smooth.pointer)) {
		N.f.j <- (diag(N.f))[i]
		U.f.test <- U.f[[i]]
		T.s.mb <- c(T.s.mb, (N.f.j * t(U.f.test) %*% (U.f.test))/n)	
	#Cauculate model-based score test for adjustment later on to the emperical form. BT CJS 1998 section 4.2
	}
	T.s.emp <- (diag(N.f)/diag(V.f)) * T.s.mb	#Calculate emperical form score test  BT CJS 1998 section 4.2
	df.test <- df.nl - 1
	T.s.chisq <- 1 - pchisq(T.s.emp, df = df.test)
	names(df.nl) <- f.smooth.names
	dimnames(f.smooth) <- dimnames(se.emp) <- dimnames(se.mb) <- list(NULL, f.smooth.names)
	list(T.s.emp = T.s.emp, T.s.mb = T.s.mb, T.s.chisq = T.s.chisq, df.nl = df.nl, df.approx = df.approx, eta.nonpar = eta.nonpar, 
		se.emp = se.emp, se.mb = se.mb, smooth.terms = f.smooth, smoother = smoother, weight = W.matrix,A.nonpar=N.f,V.nonpar=V.f,V.inv=Vinv)
}
LZ.ar1alp<-function(R, ID, cor.met, scalefun, p, df.smooth)
{
#Follow LZ Biometrika Example 4. In addition, y-axis frame shift is done to avoid invalid logarithm
	pearson <- split.preserveord(R, ID)
	times <- msplit(cor.met, ID)
	R.alpha <- rep(0, length(pearson))
	for(i in 1:length(pearson)) {
		p.i <- as.numeric(pearson[[i]])
		time.i <- as.numeric((times[[i]])[, 2])
		if(length(p.i) == 1) {
			R.alpha[i] <- 1
		}
		if(length(p.i) > 1) {
			p.i <- outer(p.i, p.i, FUN = "*")
			time.diff.i <- abs(outer(time.i, time.i, FUN = "-"))
			i.x <- i.y <- NULL
			num <- dim(p.i)[1] - 1
			for(j in 1:num) {
				i.y <- c(i.y, p.i[j, ((1 + j):(num + 1))])
				i.x <- c(i.x, time.diff.i[j, ((1 + j):(num + 1))])
			}
			i.y <- i.y + abs(min(i.y)) + 1	#y-axis vertical shift to avoid logarithm of negative value
			R.alpha[i] <- as.numeric(abs(coef(lm(log(i.y) ~ log(i.x)))[2]))
		}
	}
	R.alpha
}
